#!/bin/sh
# MTbackuper v0.02
# przeznaczony dla MikroTika v4.xx, v5.xx 
# data wydania 16.11.2011r.
# autor: seszu
# email: admin@kazuko.pl
# strona domowa: http://kazuko.pl
# wsparcie dla kluczy dsa
# wymagania: expect, client ssh, client sftp
#  - instalcja dla debiana, ubuntu itp.: aptitude install expect ssh sftp
#  - chmod +x ./MTbackuper.sh
#  - wywoływanie ./MTbackuper.sh

clear;


# kolory
RED='\033[1;31m';
GREEN='\033[1;32m';
END='\033[0m';

echo "\n  MTbackuper v0.02";
echo "    przeznaczony dla MikroTika v4.xx, v5.xx";
echo "    data wydania 16.11.2011r.";
echo "    autor: seszu";
echo "    email: admin@kazuko.pl";
echo "    strona domowa: http://kazuko.pl";
echo "    wsparcie dla kluczy dsa";
echo "    wymagania: expect, client ssh, client sftp";
echo "     - instalcja dla debiana, ubuntu itp.: aptitude install expect ssh sftp";
echo "\n   CTRL+C - anuluj";
echo "   $RED*$END - pole wymagane";

sleep 1;

echo "\n\n --> Konfiguracja: \n";
read -p "  Nazwa pliku (domyślna: MT_kopia): " nazw;
echo -n "  Host/IP (np. 192.168.2.1):$RED*$END "; read host;
read -p "  Port do ssh (domyślny: 22): " port;
read -p "  Ścieżka docelowa (domyślna: $HOME/configi): " docelowy;
read -p "  Pozostaw backup na MikroTiku tak/nie (domyślnie: nie): " pozostaw;
read -p "  Login (domyślny: admin): " login;



   if [ ! $host ]; then

       echo "\n $RED*$END Wypełnij wymagane pola. $RED*$END ";

   else

	   # wstawianie domyślnych wartości
	   if [ ! $nazw ]; then nazw="MT_kopia"; fi
	   if [ ! $port ]; then port="22"; fi
	   if [ ! $docelowy ]; then docelowy="$HOME/configi"; fi
	   if [ ! $login ]; then login="admin"; fi
	   if [ ! $pozostaw ]; then pozostaw="nie"; fi

	whoami=`whoami`;
	tmp="/tmp/$whoami/MTbackuper";


	   # tworzenie katalogu
	   if [ ! -d /tmp/$whoami ]; then mkdir /tmp/$whoami; fi






	# Weryfikacja
	echo "\n --> Weryfikacja";


	expect -c "
	spawn ssh -p $port $login@$host
	expect \"pass\"" > $tmp;

	wierszy=`cat -n $tmp | tail -1 | awk '{print $1}' | tr -d '\n'`;

	   if [ -n "`grep 'Name\sor\sservice\snot\sknown' $tmp`" ] || [ -n "`grep 'No\sroute\sto\shost' $tmp`" ] || [ -n "`grep 'Connection\stimed\sout' $tmp`" ] || [ $wierszy -le 1 ]; then
		echo "    $RED błąd!$END $RED("$END"Host nieosiągalny"$RED")$END\n";

	   elif [ -n "`grep '\sConnection\srefused' $tmp`" ]; then
		echo "    $RED błąd!$END $RED("$END"Host nieosiągalny na porcie $port"$RED")$END\n";

	   else 

		   if [ -n "`grep 'Are\syou\ssure\syou\swant\sto\scontinue\sconnecting' $tmp`" ]; then
			expect -c "
			spawn ssh -p $port $login@$host
			expect \"Are you sure you want to continue connecting (yes/no)?\"
			send \"yes\r\"
			expect \"password:\"" > $tmp;	#del# expect \"$login@$host password:\"" > $tmp;
		   fi


		   if [ -n "`grep password $tmp | tail -1`" ]; then
			pass=`grep password $tmp | tail -1`;
		   elif [ -n "`grep passphrase $tmp | tail -1`" ]; then
			pass=`grep passphrase $tmp | tail -1`;
		   fi


		stty -echo
		read -p "  $pass" haslo; echo
		stty echo;

		echo "\n --> proszę czekać...";





		# sprawdzanie poprawności hasła
		expect -c "
		spawn ssh -p $port $login@$host
		expect \"$pass\"
		send \"$haslo\r\"
		expect \"MikroTik\"" > $tmp;

		   if [ ! -n "`grep 'MikroTik' $tmp`" ]; then
			echo "    $RED błąd!$END $RED("$END"Niepoprawny login lub hasło"$RED")$END\n";
		   else 





			time=`date +"%d_%m_%G-%H_%M_%S"`;
			nazwa=$nazw"_$time";


			# Tworzenie kopii zapasowej na MikroTiku
			echo -n "\n --> Tworzenie kopii zapasowej na MikroTiku";

			expect -c "
			spawn ssh -p $port $login@$host \"/export file=$nazwa; /system backup save name=$nazwa;\"
			expect \"$pass\"
			send \"$haslo\r\"
			expect \"Configuration backup saved\"" > $tmp;
			echo -n ".";

			   for i in 1 2 3 4 5 6 7 8 9 10 ; do
				expect -c "
				spawn ssh -p $port $login@$host \"/file print detail where name=$nazwa.backup\"
				expect \"$pass\"
				send \"$haslo\r\"
				expect \"xxx\"" > $tmp;
				   if [ -n "`grep size $tmp | tail -1`" ];  then sleep 5; break; else sleep 5; echo -n ".";  fi
			   done


			   # tworzenie katalogu
			   if [ ! -d $docelowy ]; then mkdir $docelowy; fi
			   if [ ! -d $docelowy/$nazw ]; then mkdir $docelowy/$nazw; fi




			# Kopiowanie kopii zapasowej z MikroTika do ...
			echo "\n --> Kopiowanie kopii zapasowej z MikroTika do $docelowy/$nazw";

			expect -c "
			spawn sftp -P $port $login@$host
			expect \"$pass\"
			send \"$haslo\r\"
			expect \"sftp> \"
			send \"get $nazwa.rsc $docelowy/$nazw/$nazwa.rsc\r\"
			expect \"sftp> \"
			send \"get $nazwa.backup $docelowy/$nazw/$nazwa.backup\r\"
			expect \"sftp> \"
			send \"bye \r\"" > $tmp;



			   if [ $pozostaw = "nie" ]; then

				# Sprzątanie (Usuwanie kopii zapasowej z MikroTika)
				echo " --> Sprzątanie (Usuwanie kopii zapasowej z MikroTika)";

				expect -c "
				spawn ssh -p $port $login@$host \"/file remove $nazwa.backup; /file remove $nazwa.rsc;\"
				expect \"$pass\"
				send \"$haslo\r\"
				expect \"xxx\"" > $tmp;
			   elif [ $pozostaw = "tak" ]; then
				echo " --> Backup został pozostawiony na Mikrotiku";
			   fi



			echo "\n        $RED*$END KONIEC $RED*$END\n";
			echo " Pliki ($docelowy/$nazw/):";
			echo -n "  - $nazwa.backup ";
   			   if [ -e $docelowy/$nazw/$nazwa.backup ]; then echo $GREEN"ok"$END; else echo $RED"błąd!"$END; fi
			echo -n "  - $nazwa.rsc ";
   			   if [ -e $docelowy/$nazw/$nazwa.rsc ]; then echo $GREEN"ok"$END; else echo $RED"błąd!"$END; fi
			echo "\n";
		   fi
	   fi
   fi




